package com.fzm.common.properties;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @author tangtuo
 * @date 2022/1/12 16:14
 */
@Data
@Component
@ConfigurationProperties(prefix = "wx-pay")
public class WxPayProperties {

    @ApiModelProperty("微信公众号appId")
    private String appId;

    @ApiModelProperty("商户号")
    private String mchId;

    @ApiModelProperty("api v3秘钥")
    private String apiV3Key;

    @ApiModelProperty("商户api证书序列号")
    private String mchSerialNum;

    @ApiModelProperty("商户私钥文件路径")
    private String privateKeyPath;

}
