package com.fzm.portal;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fzm.common.properties.WxPayProperties;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.util.EntityUtils;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

/**
 * @author tangtuo
 * @date 2022/1/13 15:30
 */
@SpringBootTest
public class WxPayTest {


    @Resource
    private CloseableHttpClient httpClient;

    @Resource
    private WxPayProperties wxPayProperties;

    @Test
    public void testH5Pay() throws IOException {
        String url = "https://api.mch.weixin.qq.com/v3/pay/transactions/jsapi";
        HttpPost httpPost = new HttpPost(url);
        httpPost.addHeader("Accept", "application/json");
        httpPost.addHeader("Content-type","application/json; charset=utf-8");
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        ObjectMapper objectMapper = new ObjectMapper();

        ObjectNode rootNode = objectMapper.createObjectNode();
        rootNode.put("mchid",wxPayProperties.getMchId())
                .put("appid", wxPayProperties.getAppId())
                .put("description", "Image形象店-深圳腾大-QQ公仔")
                .put("notify_url", "http://www.baidu.com")
                .put("out_trade_no", "nft-123");
        rootNode.putObject("amount")
                .put("total", 1);
        rootNode.putObject("payer")
                .put("openid", "oRG0ZxPPF0fbH1KCmMV5goJ69W8I");
        String json = objectMapper.writeValueAsString(rootNode);
        System.out.println("json = " + json);
        objectMapper.writeValue(bos, rootNode);

        httpPost.setEntity(new StringEntity(bos.toString("UTF-8"), "UTF-8"));
        CloseableHttpResponse response = httpClient.execute(httpPost);

        String bodyAsString = EntityUtils.toString(response.getEntity());
        System.out.println(bodyAsString);

    }
}
